import sys
import time
import random
import os 
import math
import pygame
import pygame.mixer

class Menu:
   def __init__(self,title_img,font,option_map):
      self.title_img = title_img 
      self.font = font
      self.option_map = option_map
      self.current_list = option_map
      self.current_option = 0
      self.key_times = {pygame.K_DOWN:time.time(),\
                        pygame.K_UP:time.time(),\
                        pygame.K_RETURN:time.time()}
      self.key_lag=0.02

   def handle_keys(self,keys):
      t=time.time()
      if keys[pygame.K_DOWN] and self.key_times[pygame.K_DOWN]+self.key_lag < t:
            self.current_option=(self.current_option+1)%len(self.current_list)
            self.key_times[pygame.K_DOWN]=t
      elif keys[pygame.K_UP] and self.key_times[pygame.K_UP]+self.key_lag < t:
            self.current_option=(self.current_option-1)%len(self.current_list)
            self.key_times[pygame.K_UP]=t
      elif keys[pygame.K_RETURN] and self.key_times[pygame.K_RETURN]+self.key_lag < t:
            self.select_option(self.current_option)
            self.key_times[pygame.K_RETURN]=t

   def select_option(self,i):
      if i < 0 or i > len(self.current_list):
         return
      opt = self.current_list[i]
      if callable(opt[1]):
         opt[1]()
             
   def render(self,screen):
      screen.blit(self.title_img,(screen.get_width()/2-self.title_img.get_width()/2,10))
      mg=10
      y=mg+self.title_img.get_height()+mg
      for i in range(len(self.current_list)):
         if i == self.current_option: color = (255,0,0)
         else: color = (0,0,0)
         tsurf= self.font.render(self.current_list[i][0],True,color)
         screen.blit(tsurf,(screen.get_width()/2-tsurf.get_width()/2,y+mg)) 
         y+=tsurf.get_height()+mg
