import sys
import time
import random
import os 
import math
import pygame

class SteamJet:
   def __init__(self):
      # Particle: (pos,dir,life)
      self.particles = []
      self.cloud = (2,60) # range of cloud width 

   def add_particle(self,start,dir):
      self.particles.append((start,(dir[0]+(1-random.random()*3),dir[1]+(1-random.random()*3)),1,random.randint(self.cloud[0],self.cloud[1])))

   def tick(self):
      i=0
      for p in self.particles:
         if p[2] > p[3]: self.particles.remove(p) 
         else: self.particles[i] = ((p[0][0]+p[1][0],p[0][1]+p[1][1]),\
                                    (p[1][0]-random.random()*(p[1][0]/2),p[1][1]-random.random()*(p[1][1]/2)),\
                                    p[2]+1,p[3])
         i+=1
      if len(self.particles) == 0:
         return False
      return True
         
   def render(self,m_surf,x_offset):
      for s in self.particles:
         alpha = 255-(s[2]*(255/self.cloud[1]))
         if alpha < 0: alpha = 0
         try:  
            pygame.draw.circle(m_surf,(255,255,255,alpha),(s[0][0]-x_offset,s[0][1]),s[2])
         except OverflowError:
            print "Oops overflow"
            print s
 
